

import java.util.ArrayList;

public class Node {

    String className;
    ArrayList<Node> packageNodes;
    boolean visited = false;
    ArrayList<Edge> edges;

    
    /**
     * Constructor
     * @param className the name of the class
     */
    public Node(String className) {
        this.className = className;
        edges = new ArrayList<Edge> ();
        packageNodes = new ArrayList<Node>();
        visited = false;
    }

      
    
    /**
     * Create an edge between me and another node
     * (if it doesnt already exist)
     * let that node know there is an edge to me
     * @param node 
     */
    public void addNode(Node node) {
        if(!edgeExists(node)){
            Edge e = new Edge(this, node);
            edges.add(e);
            node.edges.add(e);
        }
    }
    
    
    
    /**
     * See if there is an existing edge between me and another node
     * @param node
     * @return boolean (edge exists or not)
     */
    private boolean edgeExists(Node node){
        Integer numEd = edges.size();
        for(int i = 0; i<numEd; i++){
            if((edges.get(i).getEndNode() == node && edges.get(i).getStartNode() == this) ||(
                    edges.get(i).getStartNode() == node && edges.get(i).getEndNode() == this))
                return true;
        }
        return false;
    }
    
    
    
    /**
     * Remove edge between me and entity node
     * @param node 
     */
    public void removeEdge(Node node) {
        edges.remove(edgeToNode(node));        
        node.edges.remove(node.edgeToNode(this));

    }
    
    
    
    /**
     * Go through all edges of my node 
     * and return the one between me and the parameter node
     * @param node
     * @return the edge leading to node
     */
    private Edge edgeToNode(Node node){
        for(int i = 0; i< edges.size(); i++){
            if(edges.get(i).getEndNode() == node || edges.get(i).getStartNode() == node)
                return edges.get(i);
        }
        return null;
    }
    

}
