


/**
 * Describe the edge in a UML class diagram
 * cardinalityFrom is the cardinality at the node owning the edge
 * cardinalityTo is the cardinality at the node 
 * @author Christina Christodoulakis <christina at cs.toronto.edu>
 */
public class Notation {
    
    private String cardinalityFrom;
    private String cardinalityTo;
    private String relationship;
    
    
    
    /**
     * Empty constructor
     */
    public Notation(){}

    
    
    /**
     * get the cardinality of the edge
     * @return String get the cardinality of the edge
     */
    public String getCardinalityFrom() {
        return cardinalityFrom;
    }
    
    
    
    /**
     * See Sets the cardinality of the edge
     * @param cardinalityFrom cardinality of the edge ('0') ('1') ('n')
     */
    public void setCardinalityFrom(String cardinalityFrom) {
        this.cardinalityFrom = cardinalityFrom;
    }

    
    
    /**
     * Retrieve the cardinality for this edge
     * @return String Cardinality of this edge
     */
    public String getCardinalityTo() {
        return cardinalityTo;
    }

    
    /**
     * Sets the cardinality for this edge
     * @param cardinalityTo ('0') ('1') ('n')
     */
    public void setCardinalityTo(String cardinalityTo) {
        this.cardinalityTo = cardinalityTo;
    }

    
    
    public String getRelationship() {
        return relationship;
    }
    
    
    /**
     * Sets the relationship type
     * (is-a, has-a, abstraction, aggregation)
     * @param relationship  relationship type
     */
    public void setNotationType(String relationship) {
        this.relationship = relationship;
    }
    
    
}
